'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _config = require('./config');

var _router = require('./router');

var _inject = require('./inject');

var _inject2 = _interopRequireDefault(_inject);

var _server = require('./server');

var _server2 = _interopRequireDefault(_server);

var _validation = require('./validation');

var _validation2 = _interopRequireDefault(_validation);

var _errors = require('./errors');

var _errors2 = _interopRequireDefault(_errors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

try {
  require('source-map-support').install();
} catch (err) {}

var Lightrail = function Lightrail(opts) {
  var _this = this;

  (0, _classCallCheck3.default)(this, Lightrail);

  (0, _config.updateConfig)(opts);

  this.start = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(cb) {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _server2.default)(cb);

            case 2:
              return _context.abrupt('return', _this);

            case 3:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }();

  this.route = function (route) {
    (0, _router.createRoute)(route);
    return _this;
  };

  this.routes = function (route) {
    (0, _router.getAllRoutes)(route);
    return _this;
  };

  this.inject = function (route) {
    return (0, _inject2.default)(route);
  };
};

module.exports = Lightrail;
module.exports.Validator = _validation2.default;
module.exports.Errors = _errors2.default;