'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _http = require('http');

var _http2 = _interopRequireDefault(_http);

var _stream = require('stream');

var _stream2 = _interopRequireDefault(_stream);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _request = require('./request');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(route) {
    var request, response, body, result;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _config2.default.logs = false;

            request = new HijackedStream(route);
            response = new _http2.default.ServerResponse(request);
            _context.next = 5;
            return (0, _request.onRequest)(request, response);

          case 5:
            body = response.output[0].split('\r\n\r\n')[1];
            result = String(response._headers['content-type']).match(/^application\/json/i) ? JSON.parse(body) : body;
            return _context.abrupt('return', (0, _extends3.default)({}, response, { result: result,
              headers: response._headers
            }));

          case 8:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();

var HijackedStream = function (_stream$Readable) {
  (0, _inherits3.default)(HijackedStream, _stream$Readable);

  function HijackedStream(route) {
    (0, _classCallCheck3.default)(this, HijackedStream);

    var _this = (0, _possibleConstructorReturn3.default)(this, Object.getPrototypeOf(HijackedStream).call(this));

    _this.method = route.method;
    _this.url = route.url;
    _this.headers = route.headers || {};
    _this.socket = {};
    _this.connection = {};

    if (route.body) {
      if (!_this.headers['content-type']) {
        _this.headers['content-type'] = 'application/json';
      }
      _this.push((0, _typeof3.default)(route.body) === 'object' ? JSON.stringify(route.body) : route.body);
    }

    _this.push(null);
    return _this;
  }

  return HijackedStream;
}(_stream2.default.Readable);