'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (tag) {
  if (!_config2.default.logs || _config2.default.logs.indexOf(tag) === -1) {
    return function () {};
  }

  var chalk = new _chalk2.default.constructor({ enabled: _config2.default.colors });

  for (var _len = arguments.length, msg = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    msg[_key - 1] = arguments[_key];
  }

  if (msg.length) {
    var timestamp = chalk.cyan('' + new Date().toISOString());
    var message = tag === 'error' ? chalk.red.apply(chalk, msg) : chalk.dim(_config2.default.name) + ' ' + timestamp + ' ' + msg.join(' ');

    process.stdout.write(message);
  }

  return function (code) {
    if (code && tag === 'request') {
      var statusCode = code >= 400 ? chalk.red(code) : chalk.green(code);
      process.stdout.write(' - ' + statusCode);
    }

    process.stdout.write('\n');
  };
};

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }