'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.runValidations = exports.getBodyData = exports.onError = exports.onRequest = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var onRequest = exports.onRequest = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(request, response) {
    var _this = this;

    var route, _ret;

    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            route = void 0;
            _context2.prev = 1;
            return _context2.delegateYield(_regenerator2.default.mark(function _callee() {
              var finishLog, hasTimedOut, getOptions, allow, requestData, responseData, preHandlers, handlerResult, result, statusCode;
              return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      finishLog = (0, _log2.default)('request', request.method, request.url, 'from', (0, _utils.getIpAddress)(request));
                      hasTimedOut = false;

                      response.setTimeout(_config2.default.timeout, function (socket) {
                        var msg = 'Max request time of ' + _config2.default.timeout / 1000 + 's reached';
                        (0, _response.sendResponse)(response, 408, new _errors2.default(408, msg));

                        hasTimedOut = true;
                        socket.destroy();
                      });

                      getOptions = request.method.match(/^options$/i);

                      route = (0, _router.lookupRoute)({
                        method: request.method,
                        url: (0, _router.removeUrlQuery)(request.url)
                      }, getOptions);

                      if (route) {
                        _context.next = 7;
                        break;
                      }

                      throw new _errors2.default().notFound();

                    case 7:
                      if (!(_config2.default.protective && !request.headers['user-agent'])) {
                        _context.next = 9;
                        break;
                      }

                      throw new _errors2.default().forbidden('Make sure your request has a User-Agent header');

                    case 9:
                      if (!getOptions) {
                        _context.next = 14;
                        break;
                      }

                      allow = Object.keys(route).map(function (r) {
                        return r.toUpperCase();
                      }).join(', ');


                      response.setHeader('Allow', allow);
                      finishLog(200);

                      return _context.abrupt('return', {
                        v: (0, _response.sendResponse)(response)
                      });

                    case 14:
                      route.validate = route.validate || {};
                      route.statusCode = route.statusCode || 200;

                      _context.next = 18;
                      return getBodyData(request);

                    case 18:
                      _context.t0 = _context.sent;
                      _context.t1 = route.validate.body;
                      _context.t2 = stripUnknownData(_context.t0, _context.t1);
                      _context.t3 = stripUnknownData((0, _router.getQueryData)(request), route.validate.query);
                      _context.t4 = (0, _router.getParamData)(request.url, route.url);
                      _context.t5 = request.headers;
                      _context.t6 = {};
                      _context.t7 = {
                        remoteAddress: (0, _utils.getIpAddress)(request)
                      };
                      requestData = {
                        body: _context.t2,
                        query: _context.t3,
                        params: _context.t4,
                        headers: _context.t5,
                        context: _context.t6,
                        info: _context.t7
                      };
                      responseData = {
                        pass: function pass(name, value) {
                          return requestData.context[name] = value;
                        },
                        setHeader: function setHeader(name, value) {
                          return response.setHeader(name, value);
                        },
                        redirect: function redirect(url) {
                          var code = arguments.length <= 1 || arguments[1] === undefined ? 301 : arguments[1];
                          return response._redirectTo = { url: url, code: code };
                        }
                      };
                      _context.next = 30;
                      return runValidations(route, requestData);

                    case 30:
                      preHandlers = _config2.default.preHandlers.concat(route.preHandlers || []);
                      _context.next = 33;
                      return (0, _utils.promiseWaterfall)(preHandlers.map(function (func) {
                        if (typeof func !== 'function') {
                          throw new TypeError('preHandlers must be an array of functions');
                        }

                        return func.bind(func, (0, _extends3.default)({}, requestData), (0, _extends3.default)({}, responseData));
                      }));

                    case 33:
                      handlerResult = route.handler(requestData, responseData);

                      if (!(handlerResult && handlerResult.then)) {
                        _context.next = 40;
                        break;
                      }

                      _context.next = 37;
                      return handlerResult;

                    case 37:
                      _context.t9 = _context.sent;
                      _context.next = 41;
                      break;

                    case 40:
                      _context.t9 = handlerResult;

                    case 41:
                      _context.t8 = _context.t9;

                      if (_context.t8) {
                        _context.next = 44;
                        break;
                      }

                      _context.t8 = { __noResponse: true };

                    case 44:
                      result = _context.t8;
                      statusCode = (typeof result === 'undefined' ? 'undefined' : (0, _typeof3.default)(result)) === 'object' && result.statusCode ? result.statusCode : route.statusCode;

                      if (!(statusCode >= 400 || result instanceof Error)) {
                        _context.next = 48;
                        break;
                      }

                      throw result;

                    case 48:
                      finishLog(statusCode);

                      if (!hasTimedOut) (0, _response.sendResponse)(response, statusCode, result);

                    case 50:
                    case 'end':
                      return _context.stop();
                  }
                }
              }, _callee, _this);
            })(), 't0', 3);

          case 3:
            _ret = _context2.t0;

            if (!((typeof _ret === 'undefined' ? 'undefined' : (0, _typeof3.default)(_ret)) === "object")) {
              _context2.next = 6;
              break;
            }

            return _context2.abrupt('return', _ret.v);

          case 6:
            _context2.next = 11;
            break;

          case 8:
            _context2.prev = 8;
            _context2.t1 = _context2['catch'](1);

            onError(response, _context2.t1, route);

          case 11:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this, [[1, 8]]);
  }));

  return function onRequest(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var onError = exports.onError = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(response, error, route) {
    var onErrorResponse, _errorResponse, _statusCode, statusCode, errorResponse, toLog;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.prev = 0;

            if (!(route && typeof route.onError === 'function')) {
              _context3.next = 13;
              break;
            }

            onErrorResponse = route.onError(error);

            if (!onErrorResponse.then) {
              _context3.next = 9;
              break;
            }

            _context3.next = 6;
            return onErrorResponse;

          case 6:
            _context3.t0 = _context3.sent;
            _context3.next = 10;
            break;

          case 9:
            _context3.t0 = onErrorResponse;

          case 10:
            _errorResponse = _context3.t0;
            _statusCode = _errorResponse.statusCode || 500;
            return _context3.abrupt('return', (0, _response.sendResponse)(response, _statusCode, _errorResponse));

          case 13:
            statusCode = error.statusCode || 500;

            (0, _log2.default)('request')(statusCode);

            errorResponse = !error.error ? new _errors2.default(statusCode, error.message || error) : error;

            if (statusCode >= 500) {
              toLog = error;

              if (!(toLog instanceof Error)) {
                toLog = new Error(JSON.stringify(toLog));
              }

              (0, _log2.default)('error', (0, _errors.cleanStackTrace)(toLog))();

              if (statusCode >= 500 && !_config2.default._isDev() && errorResponse.message) {
                delete errorResponse.message;
              }
            }

            (0, _response.sendResponse)(response, statusCode, errorResponse);
            _context3.next = 24;
            break;

          case 20:
            _context3.prev = 20;
            _context3.t1 = _context3['catch'](0);

            console.error(_context3.t1);
            (0, _response.sendResponse)(response, 500, new _errors2.default(500));

          case 24:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this, [[0, 20]]);
  }));

  return function onError(_x4, _x5, _x6) {
    return _ref2.apply(this, arguments);
  };
}();

var getBodyData = exports.getBodyData = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(request) {
    var contentType, mediaType, body;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            contentType = request.headers['content-type'] || 'text/plain; charset=utf-8';
            mediaType = _mediaTyper2.default.parse(contentType);
            _context4.next = 4;
            return (0, _rawBody2.default)(request, {
              limit: _config2.default.payloadLimit,
              length: request.headers['content-length'],
              encoding: mediaType.parameters.charset || 'utf-8'
            });

          case 4:
            body = _context4.sent;
            _context4.t0 = mediaType.subtype;
            _context4.next = _context4.t0 === 'json' ? 8 : _context4.t0 === 'x-www-form-urlencoded' ? 16 : _context4.t0 === 'plain' ? 24 : 25;
            break;

          case 8:
            _context4.prev = 8;

            body = JSON.parse(body);
            _context4.next = 15;
            break;

          case 12:
            _context4.prev = 12;
            _context4.t1 = _context4['catch'](8);
            throw new _errors2.default().badRequest('Invalid JSON payload');

          case 15:
            return _context4.abrupt('break', 26);

          case 16:
            _context4.prev = 16;

            body = _querystring2.default.parse(body);
            _context4.next = 23;
            break;

          case 20:
            _context4.prev = 20;
            _context4.t2 = _context4['catch'](16);
            throw new _errors2.default().badRequest('Invalid form data');

          case 23:
            return _context4.abrupt('break', 26);

          case 24:
            return _context4.abrupt('break', 26);

          case 25:
            throw new _errors2.default().unsupportedMediaType();

          case 26:
            return _context4.abrupt('return', body);

          case 27:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this, [[8, 12], [16, 20]]);
  }));

  return function getBodyData(_x7) {
    return _ref3.apply(this, arguments);
  };
}();

var runValidations = exports.runValidations = function () {
  var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(route, data) {
    var allErrors, validation, validate, baseError, error;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            allErrors = [];
            validation = Object.assign({}, {
              body: {}, query: {}, params: {}
            }, route.validate);

            validate = function validate(key) {
              for (var i in validation[key]) {
                var validateResult = validation[key][i].run(i, data[key][i], key);
                if (validateResult.length > 0) allErrors = allErrors.concat(validateResult);
              }
            };

            validate('body');
            validate('query');
            validate('params');
            validate('headers');

            if (!(allErrors.length > 0)) {
              _context5.next = 11;
              break;
            }

            baseError = new _errors2.default().badRequest('A validation error occured');
            error = (0, _extends3.default)({}, baseError, { validation: allErrors });
            throw error;

          case 11:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function runValidations(_x8, _x9) {
    return _ref4.apply(this, arguments);
  };
}();

exports.stripUnknownData = stripUnknownData;

var _querystring = require('querystring');

var _querystring2 = _interopRequireDefault(_querystring);

var _mediaTyper = require('media-typer');

var _mediaTyper2 = _interopRequireDefault(_mediaTyper);

var _rawBody = require('raw-body');

var _rawBody2 = _interopRequireDefault(_rawBody);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _log = require('./log');

var _log2 = _interopRequireDefault(_log);

var _response = require('./response');

var _router = require('./router');

var _utils = require('./utils');

var _errors = require('./errors');

var _errors2 = _interopRequireDefault(_errors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function stripUnknownData(data, validations) {
  if (!_config2.default.stripUnknown) return data;

  var newData = {};

  var keys = Object.keys(validations || {});
  if (keys.length === 0) return data;

  for (var i in data) {
    if (keys.indexOf(i) !== -1) {
      newData[i] = data[i];
    }
  }

  return newData;
}